; This small program execute on a boot sector
; It print the appended string and shutdown

	org 7c00h

section .text

start:
	jmp   0x0000:boot
boot:
	; set stack pointer
	xor	ax, ax
	mov	ss, ax
	mov	sp, 0fffeh
	mov	ds, ax
	mov	es, ax

%ifdef COM_LOG
	; initialize com port
	mov	dx, 0
	mov	cx, 0308h
	xor	bx, bx
	mov	ax, 0401h
	int	14h
%endif

	mov	si, string
	cld
loop_char:
	lodsb
	cmp	al, 0
	je	halt
	call	write_char
	jmp	loop_char	

	; terminate, loop waiting characters
halt:
	; try shutdown

%include "poweroff.inc"

	xor	ax, ax
	int	16h
	jmp	halt

	; Write a character
	; AL = character
write_char:
	pusha
	mov	ah, 0eh
	mov	bx,7
	int	10h
%ifdef COM_LOG
	mov	ah, 1
	mov	dx, 0
	int	14h
%endif

	popa
	ret

string:

